// RegBase_FilesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RegBase_Files.h"
#include "RegBase_FilesDlg.h"
#include "Registry.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegBaseDlg dialog

CRegBaseDlg::CRegBaseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegBaseDlg::IDD, pParent)
{
	strMainKey = _T("HKEY_CURRENT_USER\\Software\\Amir Israeli");
	strSubKey = _T("Class Check");

	//{{AFX_DATA_INIT(CRegBaseDlg)
	m_strName = _T("");
	m_iAge = 0;
	m_strPrefix = _T("");
	m_fSalary = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegBaseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegBaseDlg)
	DDX_Text(pDX, IDC_EDITNAME, m_strName);
	DDX_Text(pDX, IDC_EDITAGE, m_iAge);
	DDV_MinMaxInt(pDX, m_iAge, 0, 120);
	DDX_Text(pDX, IDC_EDITPREFIX, m_strPrefix);
	DDV_MaxChars(pDX, m_strPrefix, 3);
	DDX_Text(pDX, IDC_EDITSALARY, m_fSalary);
	DDV_MinMaxFloat(pDX, m_fSalary, 0.f, 1.e+010f);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegBaseDlg, CDialog)
	//{{AFX_MSG_MAP(CRegBaseDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnLoad)
	ON_BN_CLICKED(IDC_BUTTON2, OnSave)
	ON_BN_CLICKED(IDC_BUTTON3, OnInstall)
	ON_BN_CLICKED(IDC_BUTTON4, OnUnInstall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegBaseDlg message handlers

BOOL CRegBaseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
////////////
	//tip.AddTool(

//////////////

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRegBaseDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRegBaseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRegBaseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRegBaseDlg::OnLoad() 
{
	CRegistry  reg;
	CString str = strMainKey;
	reg.GetPathObj().AppendPath( str , strSubKey );

	CString name = _T("Name") , age = _T("Age") , prefix = _T("Prefix") , sallary = _T("Sallary");
	reg.GetValue( str , name , &m_strName);
	reg.GetValue( str , age , &m_iAge );
	reg.GetValue( str , prefix , &m_strPrefix);
	reg.GetValue( str , sallary , &m_fSalary );

	UpdateData(FALSE);

}
void CRegBaseDlg::OnSave() 
{
	UpdateData(TRUE);
	CRegistry  reg;

	CString str = strMainKey;
	reg.GetPathObj().AppendPath( str , strSubKey );
	CString name = _T("Name") , age = _T("Age"), prefix = _T("Prefix") , sallary = _T("Sallary");

	reg.SetValue( str , name , m_strName);
	reg.SetValue( str , age , &m_iAge );
	reg.SetValue( str , prefix , m_strPrefix );
	reg.SetValue( str , sallary , &m_fSalary );

}

void CRegBaseDlg::OnInstall() 
{
	CString str = strMainKey;
	if (str.IsEmpty())  return;
	CRegistry  reg;

	if (!reg.IsExistKey( str)) {
		if (!reg.CreateKey( str))  return;
	}

	reg.GetPathObj().AppendPath(str , strSubKey );
	if (str.IsEmpty())  return;

	if (!reg.IsExistKey( str)) {
		if (!reg.CreateKey( str))  return;
	}

	CString name = _T("Name") , age = _T("Age"), prefix = _T("Prefix") , sallary = _T("Sallary");

	reg.CreateValue( str , name , m_strName);
	reg.CreateValue( str , age , &m_iAge );
	reg.CreateValue( str , sallary , &m_fSalary );
	reg.CreateValue( str , prefix , m_strPrefix );
	
}
void CRegBaseDlg::OnUnInstall() 
{
	CString str = strMainKey;
	if (str.IsEmpty())  return;
	CRegistry  reg;
	reg.GetPathObj().AppendPath( str , _T("Class Check") );
	reg.DeleteKey( str);

}

BOOL CRegBaseDlg::PreTranslateMessage(MSG* pMsg) 
{
		
	return CDialog::PreTranslateMessage(pMsg);
}
